summaryrefslogtreecommitdiff
path: root/Biz/Cloud/post-receive
diff options
context:
space:
mode:
authorBen Sima <ben@bsima.me>2021-04-20 17:22:32 -0400
committerBen Sima <ben@bsima.me>2021-11-26 13:47:34 -0500
commit2b307499382691e3b4391b7accd9030cfadb0dd4 (patch)
tree093e65358c687b38cf0e34554857bef73de8c511 /Biz/Cloud/post-receive
parent6603960da6fd4bf2e65d844da116e0f507e541d3 (diff)
Publish and archive some git repos
Also adds a post-receive script that creates and publishes a git-archive of the repo at that commit. This way I can depend on my own nixpkgs fork. It took me forever but I finally figured out that I need --prefix in the git archive. I also switched to using gzip instead of xz because its faster, and I figured out how to get the sha256 that nix expects, so I can now just copy that and paste it into Biz/Bild/Sources.json.
Diffstat (limited to 'Biz/Cloud/post-receive')
-rwxr-xr-xBiz/Cloud/post-receive36
1 files changed, 36 insertions, 0 deletions
diff --git a/Biz/Cloud/post-receive b/Biz/Cloud/post-receive
new file mode 100755
index 0000000..ede443f
--- /dev/null
+++ b/Biz/Cloud/post-receive
@@ -0,0 +1,36 @@
+#!/usr/bin/env bash
+#
+# creates an archive of a git repo on push
+#
+# unfortunately the nixos gitolite module does not copy the 'commonHooks'
+# properly, so we have to manually deploy this like so:
+#
+# scp Biz/Cloud/post-receive \
+# root@simatime.com:/srv/git/.gitolite/hooks/common/post-receive
+#
+# One time only:
+#
+# ssh root@simatime.com "sudo -u git gitolite setup -ho"
+#
+# Also on first-time setup, might need to manually check the permissions are
+# correct on $webroot/archive or wherever else.
+#
+set -euo pipefail
+while read oldrev newrev refname
+do
+ repo=$(basename $PWD | sed 's/.git//g')
+ branch=$(git rev-parse --symbolic --abbrev-ref $refname)
+ webroot="/srv/www/simatime.com/"
+ outdir="$webroot/archive/$repo/$branch"
+ mkdir -p $outdir
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.tar.gz"
+ git archive "$branch" --prefix "$repo-$branch/" --format tar \
+ | gzip > "$outdir/$newrev.tar.gz"
+ echo " making: https://simatime.com/archive/$repo/$branch/$newrev.sha256"
+ hash=$(nix-prefetch-url --unpack file://$outdir/$newrev.tar.gz 2>/dev/null)
+ echo "$hash" > "$outdir/$newrev.sha256"
+ echo " commit: $newrev"
+ echo " sha256: $hash"
+ echo " in biz: deps update $repo --brach $branch --rev $newrev --attribute sha256=$hash"
+ chmod -R 755 "$webroot/archive"
+done